// JavaScript Document
var cc;
var cs;

var bW;
var bH;

var cW;
var cH;

//刻み幅

var dFlag;

var browse;

var spanArray;

//三角形の線
var tLine;

//ベクトル
var vOA;
var vOB;
var vOC;
var vOM;
var vOG;

//移動用の小ベクトル
var vA;
var vB;
var vC;

//頂点
var pA;
var pB;
var pC;
var pG;
var pM;
var pO;

//頂点の記号
var tA;
var tB;
var tC;
var tG;
var tM;
var tO;

//長さの比を表すテキストと線
var cA;

//ベクトルの記号
var tOA;
var tOB;
var tOC;
var tOG;
var tOM;

var tOA1;
var tOB1;
var tOC1;

var equal0;
var equal1;

var dVec;

var pX;
var pY;


function loadContentHandler()
{
	try
	{
		bW = pageWidth-52;
		bH = pageHeight;
		
		cW = bW;
		cH = bH;
		
		document.getElementById("configBlock").style.display = "none";
		
		document.getElementById("graphBlock").style.width = bW + "px";
		document.getElementById("graphBlock").style.height = bH + "px";
		
		document.getElementById("contentCanvas").width = bW;
		document.getElementById("contentCanvas").height = bH;
		
		cc = document.getElementById("contentCanvas");
		cs = new createjs.Stage(cc);
		
		createjs.Touch.enable(cs);
		
		//背景
		var bg = new createjs.Shape();
		bg.graphics.beginFill("#FFF");
		bg.graphics.drawRect(0, 0, cW, cH);
		bg.graphics.endFill();
		
		cs.addChild(bg);
		
		//三角形の線
		tLine = new createjs.Shape();
		cs.addChild(tLine);
		
		//二等分線
		sLine = new createjs.Shape();
		cs.addChild(sLine);
		
		//位置
		pA = createDragPoint();
		pA.name = "pA";
		pB = createDragPoint();
		pB.name = "pB";
		pC = createDragPoint();
		pC.name = "pC";
		
		pG = new createjs.Shape();
		pG.graphics.setStrokeStyle(0);
		pG.graphics.beginStroke("#007AC5");
		pG.graphics.beginFill("#007AC5");
		pG.graphics.drawCircle(0, 0, 2.5);
		pG.graphics.endFill();
		pG.graphics.endStroke();
		
		pM = new createjs.Shape();
		pO = new createjs.Shape();
		
		cs.addChild(pG);
		cs.addChild(pM);
		cs.addChild(pO);
		
		pO.x = 450;
		pO.y = 450;
		
		pA.x = pO.x;
		pA.y = pO.y - 370;
		
		pB.x = pO.x - 80;
		pB.y = pO.y - 120;
		
		pC.x = pO.x + 250;
		pC.y = pO.y - 120;
		
		pG.x = (pA.x+pB.x+pC.x)/3;
		pG.y = (pA.y+pB.y+pC.y)/3;
		
		pM.x = (pB.x+pC.x)/2;
		pM.y = (pB.y+pC.y)/2;
		
		//等長記号
		equal0 = createEqualSymbol();
		equal1 = createEqualSymbol();
		cs.addChild(equal0);
		cs.addChild(equal1);
		
		//ベクトル
		vOA = new createjs.Shape();
		vOB = new createjs.Shape();
		vOC = new createjs.Shape();
		vOM = new createjs.Shape();
		vOG = new createjs.Shape();
		
		cs.addChild(vOA);
		cs.addChild(vOB);
		cs.addChild(vOC);
		cs.addChild(vOM);
		cs.addChild(vOG);
		
		//頂点の記号
		tA = createPointText("A");
		tB = createPointText("B");
		tC = createPointText("C");
		tG = createPointText("G");
		tM = createPointText("M");
		tO = createPointText("O");
		
		cs.addChild(tO);
		cs.addChild(tA);
		cs.addChild(tB);
		cs.addChild(tC);
		cs.addChild(tG);
		cs.addChild(tM);
		cs.addChild(tO);
		
		
		//ベクトルのテキスト
		tOA = createVectorText("a");
		tOB = createVectorText("b");
		tOC = createVectorText("c");
		tOG = createVectorText("g");
		tOM = createVectorText("m");
		
		cs.addChild(tOA);
		cs.addChild(tOB);
		cs.addChild(tOC);
		cs.addChild(tOG);
		cs.addChild(tOM);
		
		
		//分数を含めたベクトルの記号
		tOA1 = createFracVectorText("a", "3", "#D60017");
		tOB1 = createFracVectorText("b", "3", "#D60017");
		tOC1 = createFracVectorText("c", "3", "#D60017");
		
		cs.addChild(tOA1);
		cs.addChild(tOB1);
		cs.addChild(tOC1);
		
		//他のドラッグ要素との兼ね合いのため，この位置でaddChild
		cs.addChild(pA);
		cs.addChild(pB);
		cs.addChild(pC);
		
		//ドラッグ用の小ベクトル
		vA = new createjs.Shape();
		vA.name = "vA";
		vB = new createjs.Shape();
		vB.name = "vB";
		vC = new createjs.Shape();
		vC.name = "vC";
		
		cs.addChild(vA);
		cs.addChild(vB);
		cs.addChild(vC);
		
		cA = createRateDisplay();
		cs.addChildAt(cA, 1);
		
		drawTriangle();
		drawSplitLine();
		changeSmallVector();
		
		changeGravityPoint();
		changeVectorPoint();
		
		changeVectorGraphics();
		changeRateDisplay();
		
		changePointTextPosition();
		
		$(".configText").css("width", "30px");
		$(".configText").css("text-align", "center");
		
		$("#check0").prop("checked", true);
		$("#check1").prop("checked", true);
		$("#check2").prop("checked", true);
		
		$("#check3").prop("checked", false);
		$("#check4").prop("checked", false);
		
		$("#check5").prop("checked", false);
		$("#check6").prop("checked", false);
		$("#check7").prop("checked", false);
		
		$("#result4").css("display", "none");
		
		animeFlag = false;
		dFlag = true;
		
		pA.addEventListener("mousedown", pointDragStart);
		pB.addEventListener("mousedown", pointDragStart);
		pC.addEventListener("mousedown", pointDragStart);
		
		vA.addEventListener("mousedown", vectorDragStart);
		vB.addEventListener("mousedown", vectorDragStart);
		vC.addEventListener("mousedown", vectorDragStart);
		
		document.getElementById("check0").addEventListener("change", changeCheckHandler);
		document.getElementById("check1").addEventListener("change", changeCheckHandler);
		document.getElementById("check2").addEventListener("change", changeCheckHandler);
		document.getElementById("check3").addEventListener("change", changeCheckHandler);
		document.getElementById("check4").addEventListener("change", changeCheckHandler);
		document.getElementById("check5").addEventListener("change", changeCheckHandler);
		document.getElementById("check6").addEventListener("change", changeCheckHandler);
		document.getElementById("check7").addEventListener("change", changeCheckHandler);
		
		document.getElementById('openBtn4').addEventListener('click', openResultHandler);
		
		document.getElementById('resetBtn').addEventListener('click', resetHandler);
		
		changeGraphDisplay();
		
		cs.update();
		
		setMenuMode(0, 320);
		
		checkVersionHandler("1.0.0");
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

function openMenuBalloonHandler(e)
{
	try
	{
		var inner;
		var data;
		
		if(e.currentTarget.id == "stepText")
		{
			inner = [0.1, 0.2, 0.5, 1, 2, 5, 10];
			data = [0.1, 0.2, 0.5, 1, 2, 5, 10];
		}
		
		openSelectBalloon("selectBalloon_menu", "menuBlock", e.currentTarget.id, inner, data, changeStepSize, 1);
		
		//
	}
	catch(e)
	{
		alert("openMenuBalloonHandler:"+e.toString());
	}
}

function createDragPoint()
{
	try
	{
		var s = new createjs.Shape();
		s.graphics.setStrokeStyle(0);
		s.graphics.beginStroke("#FF0000");
		s.graphics.beginFill("#FF0000");
		s.graphics.drawCircle(0, 0, 5);
		s.graphics.endFill();
		s.graphics.endStroke();
		
		s.graphics.beginStroke("rgba(255,255,255,0.02)");
		s.graphics.beginFill("rgba(255,255,255,0.02)");
		s.graphics.drawCircle(0, 0, 15);
		s.graphics.endFill();
		s.graphics.endStroke();
		
		s.alpha = 0.5;
		
		return s;
	}
	catch(e)
	{
		alert("createDragPoint:" + e.toString());
	}
}

function createPointText(str)
{
	try
	{
		var c = new createjs.Container();
		var t = new createjs.Text(str, "20px Times New Roman", "#000000");
		t.x = -t.getBounds().width/2;
		t.y = -t.getBounds().height/2;
		c.addChild(t);
		
		return c;
	}
	catch(e)
	{
		alert("createTextPosition:" + e.toString());
	}
}

//二等分線の比を表す表示のコンテナ
function createRateDisplay()
{
	try
	{
		var c = new createjs.Container();

		var t1 = createPointText("1");
		t1.name = "t1";
		c.addChild(t1);

		var t2 = createPointText("2");
		t2.name = "t2";
		c.addChild(t2);
		
		var s1 = new createjs.Shape();
		s1.graphics.setStrokeStyle(0);
		s1.graphics.beginStroke("#FFFFFF");
		s1.graphics.beginFill("#FFFFFF");
		s1.graphics.drawCircle(0, 0, 16);
		s1.graphics.endFill();
		s1.graphics.endStroke();
		t1.addChildAt(s1, 0);

		var s2 = new createjs.Shape();
		s2.graphics.setStrokeStyle(0);
		s2.graphics.beginStroke("#FFFFFF");
		s2.graphics.beginFill("#FFFFFF");
		s2.graphics.drawCircle(0, 0, 16);
		s2.graphics.endFill();
		s2.graphics.endStroke();
		t2.addChildAt(s2, 0);
		
		var line = new createjs.Shape();
		line.name = "line";
		c.addChildAt(line, 0);
		
		return c;
	}
	catch(e)
	{
		alert("createRateDisplay:" + e.toString());
	}
}

function changeRateDisplay()
{
	try
	{
		var mX = (pB.x+pC.x)/2;
		var mY = (pB.y+pC.y)/2;
		
		changeVectorTextPosition(cA.getChildByName("t2"), pA.x, pA.y, pG.x, pG.y, false);
		changeVectorTextPosition(cA.getChildByName("t1"), pG.x, pG.y, mX, mY, false);
		
		/*
		範囲の線保留
		//幅を表す曲線のコントロールの座標
		//１の数字の曲線
		var c1X = (pG.x+mX)/2;
		var c1Y = (pG.y+mY)/2;
		
		leng1 = Math.sqrt((t1.x-c1X)*(t1.x-c1X)+(t1.y-c1Y)*(t1.y-c1Y));
		r1 = Math.atan2(t1.y-c1Y, t1.x-c1X);
		
		c1X = c1X + leng1 * 2 * Math.cos(r1);
		c1Y = c1Y + leng1 * 2 * Math.sin(r1);
		
		//２の数字の曲線
		var c2X = (p.x+pG.x)/2;
		var c2Y = (p.y+pG.y)/2;
		
		leng2 = Math.sqrt((t2.x-c2X)*(t2.x-c2X)+(t2.y-c2Y)*(t2.y-c2Y));
		r2 = Math.atan2(t2.y-c2Y, t2.x-c2X);
		
		c2X = c2X + leng2 * 2 * Math.cos(r2);
		c2Y = c2Y + leng2 * 2 * Math.sin(r2);
		
		//曲線の描画
		var line = cA.getChildByName("line");
		line.graphics.clear();
		line.graphics.setStrokeStyle(1);
		line.graphics.beginStroke("#000000");
		
		line.graphics.moveTo(p.x, p.y);
		line.graphics.curveTo(c2X, c2Y, pG.x, pG.y);
		
		line.graphics.moveTo(pG.x, pG.y);
		line.graphics.curveTo(c1X, c1Y, mX, mY);
		
		line.graphics.endStroke();
		*/
	}
	catch(e)
	{
		alert("changeRateDisplay:" + e.toString());
	}
}

function createVectorText(str, color)
{
	try
	{
		if(color == null)
		{
			color = "#000000";
		}
		
		var c = new createjs.Container();
		
		var leng = str.length;
		
		var tW = 0;
		
		for(var i=0; i<leng; i++)
		{
			var s = str.substring(i, i+1);
			
			var t;
			
			//ベクトル記号が必要なテキスト
			if(s == "a" || s == "b" || s == "c" || s == "g" || s == "m")
			{
				var ct = new createjs.Container();
				t = new createjs.Text(s, "Italic 18px Times New Roman", color);
				ct.addChild(t);
				
				var w = t.getBounds().width;
				
				var vs = new createjs.Shape();
				changeArrowShape(vs, -2, 0, w+2, 0, color, false);
				ct.addChild(t);
				ct.addChild(vs);
				
				vs.y = -2;
				
				c.addChild(ct);
				tW += w;
			}
			else
			{
				t = new createjs.Text(s, "18px Times New Roman", color);
				c.addChild(t);
				tW += t.getBounds().width;
			}
		}
		
		tW = -tW/2;
		
		leng = c.getNumChildren();
		//テキストの位置調整
		for(i=0; i<leng; i++)
		{
			var t = c.getChildAt(i);
			t.x = tW;
			t.y = -8;
			tW += t.getBounds().width;
		}
		
		return c;
	}
	catch(e)
	{
		alert("createVectorText:" + e.toString());
	}
}

function createFracVectorText(str0, str1, color)
{
	if(color == null)
	{
		color = "#000000";
	}
	
	var c = new createjs.Container();
	
	var t0 = createVectorText(str0, color);
	
	var t1 = new createjs.Text(str1, "18px Times New Roman", color);
	
	c.addChild(t0);
	c.addChild(t1);
	
	var w0 = t0.getBounds().width;
	var w1 = t1.getBounds().width;
	
	t0.x = 0;
	t0.y = -t0.getBounds().height/2-2;
	t1.x = -w1/2;
	t1.y = 2;
	
	var w = Math.max(w0, w1);
	
	var s = new createjs.Shape();
	s.graphics.setStrokeStyle(1);
	s.graphics.beginStroke(color);
	s.graphics.moveTo(-w/2-2, 0);
	s.graphics.lineTo(w/2+2, 0);
	s.graphics.endStroke();
	c.addChild(s);
	
	return c;
}

function createEqualSymbol()
{
	try
	{
		var s = new createjs.Shape();
		s.graphics.setStrokeStyle(1.5);
		s.graphics.beginStroke("#000000");
		s.graphics.moveTo(-2, -6);
		s.graphics.lineTo(-2, 6);
		s.graphics.moveTo(2, -6);
		s.graphics.lineTo(2, 6);
		s.graphics.endStroke();
		
		return s;
	}
	catch(e)
	{
		alert("createEqualSymbol:" + e.toString());
	}
}

function drawTriangle()
{
	try
	{
		tLine.graphics.clear();
		tLine.graphics.setStrokeStyle(1.5);
		tLine.graphics.beginStroke("#007700");
		tLine.graphics.moveTo(pA.x, pA.y);
		tLine.graphics.lineTo(pB.x, pB.y);
		tLine.graphics.lineTo(pC.x, pC.y);
		tLine.graphics.lineTo(pA.x, pA.y);
		tLine.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawTriangle:" + e.toString());
	}
}

function drawSplitLine()
{
	try
	{
		sLine.graphics.clear();
		sLine.graphics.setStrokeStyle(1);
		sLine.graphics.beginStroke("#000000");
		sLine.graphics.moveTo(pA.x, pA.y);
		sLine.graphics.lineTo((pB.x+pC.x)/2, (pB.y+pC.y)/2);
		
		/*
		sLine.graphics.moveTo(pB.x, pB.y);
		sLine.graphics.lineTo((pC.x+pA.x)/2, (pC.y+pA.y)/2);
		sLine.graphics.moveTo(pC.x, pC.y);
		sLine.graphics.lineTo((pA.x+pB.x)/2, (pA.y+pB.y)/2);
		*/
		
		sLine.graphics.endStroke();
		
	}
	catch(e)
	{
		alert("changeSplitLine:" + e.toString());
	}
}

function changePointTextPosition()
{
	try
	{
		tA.x = pA.x;
		tA.y = pA.y-10;
		tB.x = pB.x-10;
		tB.y = pB.y+10;
		tC.x = pC.x+10;
		tC.y = pC.y+10;
		
		tO.x = pO.x;
		tO.y = pO.y+10;
		
		tG.x = pG.x+10;
		tG.y = pG.y-10;
		
		tM.x = pM.x+10;
		tM.y = pM.y+10;
		
		var leng = Math.sqrt((pB.x-pC.x)*(pB.x-pC.x)+(pB.y-pC.y)*(pB.y-pC.y));
		var r = Math.atan2(pC.y-pB.y, pC.x-pB.x);
		
		equal0.x = pB.x + leng/3 * Math.cos(r);
		equal0.y = pB.y + leng/3 * Math.sin(r);
		equal1.x = pB.x + leng*2/3 * Math.cos(r);
		equal1.y = pB.y + leng*2/3 * Math.sin(r);
		
		equal0.rotation = r * 180/Math.PI;
		equal1.rotation = r * 180/Math.PI;
		
		changeFracTextPosition(-1);
	}
	catch(e)
	{
		alert("changePointTextPosition:" + e.toString());
	}
}

function changeCheckHandler(e)
{
	try
	{
		var id = e.currentTarget.id;
		var n = parseInt(id.substring(id.length-1, id.length));
		
		changeGraphDisplay();
		
		cs.update();
	}
	catch(e)
	{
		alert(e.toString());
	}
}

function changeGraphDisplay()
{
	try
	{
		//ベクトルa
		var f = $("#check0").prop("checked");
		vOA.visible = f;
		tOA.visible = f;
		
		//ベクトルb
		f = $("#check1").prop("checked");
		vOB.visible = f;
		tOB.visible = f;
		
		//ベクトルc
		f = $("#check2").prop("checked");
		vOC.visible = f;
		tOC.visible = f;
		
		//ベクトルm
		f = $("#check3").prop("checked");
		vOM.visible = f;
		tOM.visible = f;
		tM.visible = f;
		equal0.visible = f;
		equal1.visible= f;
		
		//ベクトルg
		f = $("#check4").prop("checked");
		pG.visible = f;
		vOG.visible = f;
		tOG.visible = f;
		tG.visible = f;
		cA.visible = f;
		sLine.visible = f;
		
		//a/3
		f = $("#check5").prop("checked");
		vA.visible = f;
		tOA1.visible = f;
		
		//b/3
		f = $("#check6").prop("checked");
		vB.visible = f;
		tOB1.visible = f;
		
		//c/3
		f = $("#check7").prop("checked");
		vC.visible = f;
		tOC1.visible = f;
	}
	catch(e)
	{
		alert("changeGraphDisplay:" + e.toString());
	}
}

function changeGravityDisplay()
{
	try
	{
		var f = $("#check0").prop("checked");
		
		vOG.visible = f;
		tOG.visible = f;
		tG.visible = f;
		vA.visible = f;
		vB.visible = f;
		vC.visible = f;
		
		cs.update();
	}
	catch(e)
	{
		alert("changeGravityDisplay:" + e.toString());
	}
}

function openResultHandler(e)
{
	try
	{
		if($("#result4").css("display") == "none")
		{
			$("#result4").css("display", "block");
		}
		else
		{
			$("#result4").css("display", "none");
		}
	}
	catch(e)
	{
		alert("openResultHandler:" + e.toString());
	}
}

function changeGravityPoint()
{
	try
	{
		pG.x = (pA.x+pB.x+pC.x)/3;
		pG.y = (pA.y+pB.y+pC.y)/3;
		
		pM.x = (pB.x+pC.x)/2;
		pM.y = (pB.y+pC.y)/2;
	}
	catch(e)
	{
		alert("changeGravityPoint:" + e.toString());
	}
}

function changeVectorPoint()
{
	try
	{
		changeVectorTextPosition(tOA, pO.x, pO.y, pA.x, pA.y, false);
		changeVectorTextPosition(tOB, pO.x, pO.y, pB.x, pB.y, false);
		changeVectorTextPosition(tOC, pO.x, pO.y, pC.x, pC.y, true);
		
		changeVectorTextPosition(tOG, pO.x, pO.y, pG.x, pG.y, true);
		
		changeVectorTextPosition(tOM, pO.x, pO.y, pM.x, pM.y, true);
	}
	catch(e)
	{
		alert("changeVectorPoint:" + e.toString());
	}
}

//ベクトルのグラフィック再描画
function changeVectorGraphics()
{
	try
	{
		changeArrowShape(vOA, pO.x, pO.y, pA.x, pA.y, "#000000", true);
		changeArrowShape(vOB, pO.x, pO.y, pB.x, pB.y, "#000000", true);
		changeArrowShape(vOC, pO.x, pO.y, pC.x, pC.y, "#000000", true);
		
		changeArrowShape(vOG, pO.x, pO.y, pG.x, pG.y, "#007AC5", 2);
		
		changeArrowShape(vOM, pO.x, pO.y, pM.x, pM.y, "#888888", 2);
	}
	catch(e)
	{
		alert("changeVectorGraphics:" + e.toString());
	}
}

function changeSmallVector()
{
	try
	{
		vA.x = pO.x;
		vA.y = pO.y;
		vB.x = pO.x;
		vB.y = pO.y;
		vC.x = pO.x;
		vC.y = pO.y;
		
		vA.graphics.clear();
		vA.graphics.setStrokeStyle(2);
		vA.graphics.beginStroke("#000000");
		vA.graphics.drawCircle(0, 0, 20);
		vA.graphics.endStroke();
		
		changeArrowShape(vA, 0, 0, (pA.x-pO.x)/3, (pA.y-pO.y)/3, "#D60017", true);
		changeArrowShape(vB, 0, 0, (pB.x-pO.x)/3, (pB.y-pO.y)/3, "#D60017", true);
		changeArrowShape(vC, 0, 0, (pC.x-pO.x)/3, (pC.y-pO.y)/3, "#D60017", true);
		
		vA.graphics.setStrokeStyle(30, 1);
		vA.graphics.beginStroke("rgba(255,255,255,0.02)");
		vA.graphics.moveTo(0,0);
		vA.graphics.lineTo((pA.x-pO.x)/3, (pA.y-pO.y)/3);
		vA.graphics.endStroke();
		
		vB.graphics.setStrokeStyle(30, 1);
		vB.graphics.beginStroke("rgba(255,255,255,0.02)");
		vB.graphics.moveTo(0,0);
		vB.graphics.lineTo((pB.x-pO.x)/3, (pB.y-pO.y)/3);
		vB.graphics.endStroke();
		
		vC.graphics.setStrokeStyle(30, 1);
		vC.graphics.beginStroke("rgba(255,255,255,0.02)");
		vC.graphics.moveTo(0,0);
		vC.graphics.lineTo((pC.x-pO.x)/3, (pC.y-pO.y)/3);
		vC.graphics.endStroke();
		
	}
	catch(e)
	{
		alert("changeSmallVector:" + e.toString());
	}
}

//ベクトルのテキストの位置修正
function changeVectorTextPosition(t, x0, y0, x1, y1, f)
{
	try
	{
		var tX = (x0+x1)/2;
		var tY = (y0+y1)/2;
		
		var leng;
		
		if(t.getBounds().width >= t.getBounds().height)
		{
			leng = t.getBounds().width/2 + 10;
		}
		else
		{
			leng = t.getBounds().height/2 + 10;
		}
		
		var r;
		
		if(f)
		{
			r = Math.atan2(y1-y0, x1-x0) + Math.PI/2;
		}
		else
		{
			r = Math.atan2(y1-y0, x1-x0) - Math.PI/2;
		}
		
		t.x = tX + leng * Math.cos(r);
		t.y = tY + leng * Math.sin(r);
	}
	catch(e)
	{
		alert("changeVectorTextPosition:" + e.toString());
	}
}

function changeFracTextPosition(n)
{
	try
	{
		var tX;
		var tY;
		
		if(n == -1 || n == 0)
		{
			tX = vA.x + (pA.x-pO.x)/3;
			tY = vA.y + (pA.y-pO.y)/3;
			changeVectorTextPosition(tOA1, vA.x, vA.y, tX, tY, false);
		}
		
		if(n == -1 || n == 1)
		{
			tX = vB.x + (pB.x-pO.x)/3;
			tY = vB.y + (pB.y-pO.y)/3;
			changeVectorTextPosition(tOB1, vB.x, vB.y, tX, tY, false);
		}
		
		if(n == -1 || n == 2)
		{
			tX = vC.x + (pC.x-pO.x)/3;
			tY = vC.y + (pC.y-pO.y)/3;
			changeVectorTextPosition(tOC1, vC.x, vC.y, tX, tY, false);
		}
	}
	catch(e)
	{
		alert("changeFracTextPosition:" + e.toString());
	}
}

function pointDragStart(e)
{
	try
	{
		if(dFlag)
		{
			dFlag = false;
			
			dVec = e.currentTarget;
			
			pX = e.stageX;
			pY = e.stageY;
			
			cs.addEventListener("pressmove", pointDragMove);
			cs.addEventListener("pressup", pointDragStop);
			cs.addEventListener("mouseout", pointDragStop);
		}
	}
	catch(e)
	{
		alert("pointDragStart:" + e.toString());
	}
}

function pointDragMove(e)
{
	try
	{
		dVec.x = e.stageX;
		dVec.y = e.stageY;
		
		drawTriangle();
		drawSplitLine();
		changeSmallVector();
		
		changeGravityPoint();
		changeVectorPoint();
		
		changeVectorGraphics();
		changeRateDisplay();
		
		changePointTextPosition();
		
		cs.update();
	}
	catch(e)
	{
		alert("pointDragMove:" + e.toString());
	}
}

function pointDragStop(e)
{
	try
	{
		dFlag = true;
		
		cs.removeEventListener("pressmove", pointDragMove);
		cs.removeEventListener("pressup", pointDragStop);
		cs.removeEventListener("mouseout", pointDragStop);
	}
	catch(e)
	{
		alert("pointDragStop:" + e.toString());
	}
}

function vectorDragStart(e)
{
	try
	{
		if(dFlag)
		{
			dFlag = false;
			
			dVec = e.currentTarget;
			
			cs.setChildIndex(dVec, cs.getNumChildren()-1);
			
			pX = e.stageX;
			pY = e.stageY;
			
			cs.addEventListener("pressmove", vectorDragMove);
			cs.addEventListener("pressup", vectorDragStop);
			cs.addEventListener("mouseout", vectorDragStop);
		}
	}
	catch(e)
	{
		alert("vectorDragStart:" + e.toString());
	}
}

function vectorDragMove(e)
{
	try
	{
		var sX = e.stageX;
		var sY = e.stageY;
		
		dVec.x += sX - pX;
		dVec.y += sY - pY;
		
		pX = sX;
		pY = sY;
		
		var n;
		
		switch(dVec.name)
		{
			case "vA":
				n = 0;
				break;
			case "vB":
				n = 1;
				break;
			case "vC":
				n = 2;
				break;
		}
		
		changeFracTextPosition(n);
		
		cs.update();
	}
	catch(e)
	{
		alert("vectorDragMove:" + e.toString());
	}
}

function vectorDragStop(e)
{
	try
	{
		
		dFlag = true;
		
		var check = checkVectorConnect(dVec);
		
		if(check[0])
		{
			dVec.x += check[1];
			dVec.y += check[2];
			
			cs.update();
		}
		
		cs.removeEventListener("pressmove", vectorDragMove);
		cs.removeEventListener("pressup", vectorDragStop);
		cs.removeEventListener("mouseout", vectorDragStop);
	}
	catch(e)
	{
		alert("vectorDragStop:" + e.toString());
	}
}

function checkVectorConnect(vec)
{
	try
	{
		//端点をつなげるかの判定
		var array = [false];
		
		//2点間の比較する距離
		var d = 30;
		
		//ドラッグしたベクトルの端点の座標
		var vArray = [];
		vArray[0] = [vec.x, vec.y];
		
		//比較するベクトルの端点の座標
		var rArray = [];
		
		if(vec.name == "vA")
		{
			vArray[1] = [vec.x+(pA.x-pO.x)/3, vec.y+(pA.y-pO.y)/3];
			
			rArray[0] = [vB.x, vB.y];
			rArray[1] = [vB.x+(pB.x-pO.x)/3, vB.y+(pB.y-pO.y)/3];
			rArray[2] = [vC.x, vC.y];
			rArray[3] = [vC.x+(pC.x-pO.x)/3, vC.y+(pC.y-pO.y)/3];
		}
		else if(vec.name == "vB")
		{
			vArray[1] = [vec.x+(pB.x-pO.x)/3, vec.y+(pB.y-pO.y)/3];
			
			rArray[0] = [vC.x, vC.y];
			rArray[1] = [vC.x+(pC.x-pO.x)/3, vC.y+(pC.y-pO.y)/3];
			rArray[2] = [vA.x, vA.y];
			rArray[3] = [vA.x+(pA.x-pO.x)/3, vA.y+(pA.y-pO.y)/3];
		}
		else
		{
			vArray[1] = [vec.x+(pC.x-pO.x)/3, vec.y+(pC.y-pO.y)/3];
			
			rArray[0] = [vA.x, vA.y];
			rArray[1] = [vA.x+(pA.x-pO.x)/3, vA.y+(pA.y-pO.y)/3];
			rArray[2] = [vB.x, vB.y];
			rArray[3] = [vB.x+(pB.x-pO.x)/3, vB.y+(pB.y-pO.y)/3];
		}
		
		rArray[4] = [pO.x, pO.y];
		rArray[5] = [pG.x, pG.y];
		
		var r = rArray.length;
		
		for(var i=0; i<2; i++)
		{
			for(var j=0; j<r; j++)
			{
				//２点間の距離
				var leng = Math.sqrt((rArray[j][0]-vArray[i][0])*(rArray[j][0]-vArray[i][0])+(rArray[j][1]-vArray[i][1])*(rArray[j][1]-vArray[i][1]));
				
				//距離を比較し，最短の位置に合わせる
				if(leng < d)
				{
					d = leng;
					
					array[0] = true;
					array[1] = rArray[j][0]-vArray[i][0];
					array[2] = rArray[j][1]-vArray[i][1];
				}
			}
		}
		
		return array;
	}
	catch(e)
	{
		alert("checkVectorConnect:" + e.toString());
	}
}

function saveContent()
{
	try
	{
		var array = [];
		
		array[0] = [];
		array[0][0] = $("#check0").prop("checked");
		array[0][1] = $("#check1").prop("checked");
		array[0][2] = $("#check2").prop("checked");
		array[0][3] = $("#check3").prop("checked");
		array[0][4] = $("#check4").prop("checked");
		array[0][5] = $("#check5").prop("checked");
		array[0][6] = $("#check6").prop("checked");
		array[0][7] = $("#check7").prop("checked");
		
		array[1] = [pA.x, pA.y];
		array[2] = [pB.x, pB.y];
		array[3] = [pC.x, pC.y];
		
		array[4] = $("#result4").css("display");
		
		array[5] = [vA.x, vA.y];
		array[6] = [vB.x, vB.y];
		array[7] = [vC.x, vC.y];
		
		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

function loadContent(array)
{
	try
	{
		$("#check0").prop("checked", array[0][0]);
		$("#check1").prop("checked", array[0][1]);
		$("#check2").prop("checked", array[0][2]);
		$("#check3").prop("checked", array[0][3]);
		$("#check4").prop("checked", array[0][4]);
		$("#check5").prop("checked", array[0][5]);
		$("#check6").prop("checked", array[0][6]);
		$("#check7").prop("checked", array[0][7]);
		
		pA.x = array[1][0];
		pA.y = array[1][1];
		pB.x = array[2][0];
		pB.y = array[2][1];
		pC.x = array[3][0];
		pC.y = array[3][1];
		
		$("#result4").css("display", array[4]);
		
		//以下再描画関連を実行
		drawTriangle();
		drawSplitLine();
		changeSmallVector();
		
		changeGravityPoint();
		changeVectorPoint();
		
		changeVectorGraphics();
		changeRateDisplay();
		
		changePointTextPosition();
		
		changeGraphDisplay();
		
		vA.x = array[5][0];
		vA.y = array[5][1];
		
		vB.x = array[6][0];
		vB.y = array[6][1];
		
		vC.x = array[7][0];
		vC.y = array[7][1];
		
		cs.update();
	}
	catch(e)
	{
		alert("loadContent:" + e.toString());
	}
}

function resetHandler(e)
{
	try
	{
		pA.x = pO.x;
		pA.y = pO.y - 370;
		
		pB.x = pO.x - 80;
		pB.y = pO.y - 120;
		
		pC.x = pO.x + 250;
		pC.y = pO.y - 120;
		
		$("#check0").prop("checked", true);
		$("#check1").prop("checked", true);
		$("#check2").prop("checked", true);
		$("#check3").prop("checked", false);
		$("#check4").prop("checked", false);
		$("#check5").prop("checked", false);
		$("#check6").prop("checked", false);
		$("#check7").prop("checked", false);
		
		$("#result4").css("display", "none");
		
		drawTriangle();
		drawSplitLine();
		changeSmallVector();
		
		changeGravityPoint();
		changeVectorPoint();
		
		changeVectorGraphics();
		changeRateDisplay();
		
		changePointTextPosition();
		
		changeGraphDisplay();
		
		cs.update();
	}
	catch(e)
	{
		alert('resetHandler:' + e.toString());
	}
}
